#ifndef PLURALSTR
#define PLURALSTR				2.00



int Pl_AllCaps( LPCTSTR String )
{
	if ( !String )
		return 0;


	unsigned int Upper		= 0;
	unsigned int Lower		= 0;


	for ( const wchar_t *ch = String; *ch; ch++ ) {
		if ( iswupper( *ch ) )
			Upper++;
		else if ( iswlower( *ch ) )
			Lower++;
	}

	if ( Lower )
		return 0;
	else if ( Upper == 1 )
		return 1;
	else if ( Upper )
		return 2;
	else
		return 0;
}



BOOL Pl_Vowel( wchar_t ch )
{
	ch = towupper( ch );

	if ( ( ch == 'A' ) || ( ch == 'E' ) || ( ch == 'I' ) || ( ch == 'O' ) || ( ch == 'U' ) )
		return TRUE;

	return FALSE;
}



BOOL Pl_Consonant( wchar_t ch )
{
	if ( iswalpha( ch ) )
		if ( !Pl_Vowel( ch ) )
			return TRUE;

	return FALSE;
}



LPCTSTR Plural( unsigned __int64 n, LPCTSTR Singular, LPCTSTR PluralStr = NULL )
{
	static wchar_t temp[SHORT_BUF_LEN]		= L"";
	const wchar_t Default[]					= L"thing";
	size_t len								= 0;
	wchar_t a[3]							= { '\0', '\0', '\0' };


	if ( !Singular )
		Singular = Default;
	else if ( Singular[0] == '\0' )
		Singular = Default;

	if ( n == 1 )
		return Singular;

	if ( PluralStr )
		if ( PluralStr[0] == '\0' )
			PluralStr = NULL;

	if ( PluralStr )
		return PluralStr;


	wcscpy_s( temp, SHORT_BUF_LEN, Singular );
	len = wcslen( temp );

	if ( len )
		a[0]	= towupper( temp[len - 1] );

	if ( len > 1 )
		a[1]	= towupper( temp[len - 2] );

	if ( len > 2 )
		a[2]	= towupper( temp[len - 3] );


	if ( Pl_Consonant( a[1] ) && ( a[0] == 'Y' ) ) {
		temp[len - 1] = '\0';
		wcscat_s( temp, SHORT_BUF_LEN, L"ies" );
	}
	else if ( ( a[1] == 'I' ) && ( a[0] == 'S' ) )
		temp[len - 2] = 'e';
	else if ( ( a[1] == 'E' ) && ( a[0] == 'X' ) ) {
		temp[len - 2] = '\0';
		wcscat_s( temp, SHORT_BUF_LEN, L"ices" );
	}
	else if ( ( a[0] == 'S' ) || ( a[0] == 'X' ) || ( a[0] == 'O' ) || ( ( a[1] == 'S' ) && ( a[0] == 'H' ) ) || ( ( a[1] == 'C' ) && ( a[0] == 'H' ) ) )
		wcscat_s( temp, SHORT_BUF_LEN, L"es" );
	else if ( ( a[2] == 'M' ) && ( a[1] == 'A' ) && ( a[0] == 'N' ) )
		temp[len - 2] = 'e';
	else if ( ( a[2] == 'E' ) && ( a[1] == 'L' ) && ( a[0] == 'F' ) ) {
		temp[len - 1] = '\0';
		wcscat_s( temp, SHORT_BUF_LEN, L"ves" );
	}
	else
		wcscat_s( temp, SHORT_BUF_LEN, L"s" );


	if ( Pl_AllCaps( Singular ) > 1 )
		_wcsupr_s( temp, SHORT_BUF_LEN );

	return temp;
}



LPCTSTR PluralN( unsigned __int64 n, LPCTSTR Singular, LPCTSTR PluralStr = NULL )
{
	static wchar_t temp[SHORT_BUF_LEN]		= L"";


	wsprintf( temp, L"%%@comma[%I64u] ", n );
	ExpandVariables( temp, 1 );
	wcscat_s( temp, SHORT_BUF_LEN, Plural( n, Singular, PluralStr ) );
	return temp;
}



LPCTSTR PluralNW( unsigned __int64 n, unsigned short int Width, LPCTSTR Singular, LPCTSTR PluralStr = NULL )
{
	static wchar_t temp[SHORT_BUF_LEN]		= L"";
	wchar_t num[SHORT_BUF_LEN]				= L"";
	size_t l								= 0;
	unsigned short int a					= 0;


	wsprintf( num, L"%%@comma[%I64u]", n );
	ExpandVariables( num, 1 );
	l = wcslen( num );

	if ( l < (size_t) Width ) {
		a = Width - (unsigned short int) l;
		for ( unsigned short int i = 0; i < a; i++ )
			temp[i] = 0x20;

		temp[a] = '\0';
	}

	wcscat_s( temp, SHORT_BUF_LEN, num );
	wcscat_s( temp, SHORT_BUF_LEN, L" " );
	wcscat_s( temp, SHORT_BUF_LEN, Plural( n, Singular, PluralStr ) );
	return temp;
}



#endif	//	PLURALSTR
